###################################################
### chunk number 1: 
###################################################
library(ISA)


###################################################
### chunk number 2: 1-4-1-risposta1
###################################################
valoreX3 <- seq(100,104,0.5)
#valoreX3
# Calcolo del campo di variazione
resCampoVar <- unlist(lapply(valoreX3,function(vx){
        max(c(100,100,vx))-min(c(100,100,vx)) })
        )    
#resCampoVar
tabellaRisultato <- cbind(x1=100,x2=100,x3=valoreX3,Acv=resCampoVar)
dimevaloreX3 <-length(valoreX3)
valoreD1 <- unlist(lapply(valoreX3,function(vx){
           dataset <- c(100,100,vx)
         difSempliceMed(dataset) })
        ) 
tabellaRisultato <- cbind(tabellaRisultato,D1 = valoreD1) 
#tabellaRisultato                    
valoreSSM <- unlist(lapply(valoreX3,function(vx){
           dataset <- c(100,100,vx)
            sum(abs(dataset-mean(dataset))/3) })
        ) 
tabellaRisultato <- cbind(tabellaRisultato,Ssm = valoreSSM)
#tabellaRisultato           
valore <- unlist(lapply(valoreX3,function(vx){
           dataset <- c(100,100,vx)
           sqrt(var(dataset)*2/3) })
        ) 
tabellaRisultato <- cbind(tabellaRisultato,
                     S = valore,
                     S2 = valore^2)
# Risposta primo quesito             
rownames(tabellaRisultato)<-character(dimevaloreX3)
tabellaRisultato


###################################################
### chunk number 3: 1-4-1-risposta2
###################################################
plot(NA,xlim=c(100,104.5),ylim=c(0,4),type="n",axes=F,xlab="x3",ylab="")
for(aux in 4:8)lines(valoreX3,tabellaRisultato[,aux],
         col=aux,lty = aux,lwd=2)
legend(100,4,legend=dimnames(tabellaRisultato)[[2]][4:8],
        col=4:8,lty=4:8)
axis(1,at=valoreX3,xlab="x3")
axis(2,at=0:4,ylab="")
box()


###################################################
### chunk number 4: 1-4-2-risposta1a
###################################################
NumeroFoglie <- c(0,1,2,3,4);
FrequenzaCum <- c(0.152,0.3678,0.4894,0.8116,1.0000);
FrequenzaRel <- diff(c(0,FrequenzaCum ));
FrequenzaAss <- round(329*FrequenzaRel,0)
matrix(c(NumeroFoglie,FrequenzaAss),ncol=2,dimnames=list(character(5),c("Numero foglie","Freq")))


###################################################
### chunk number 5: 1-4-2-risposta1
###################################################
barplot(FrequenzaAss,names.arg=paste(NumeroFoglie),ylim=c(0,120),xlab="Numero foglie",ylab="Freq")
box()
title("Diagramma di frequenze assolute")


###################################################
### chunk number 6: 1-4-2-risposta2
###################################################
valoriElementari <- rep(NumeroFoglie,FrequenzaAss)
Mediana <- quantile(valoriElementari,0.5,type=1)
Moda <- as.numeric(names(moda(valoriElementari)))
Media <- mean(valoriElementari)
matrix(c(Mediana,Moda,Media),nrow=3,dimnames=list(c("Mediana:","Moda:","Media:"),character(1)))


###################################################
### chunk number 7: 1-4-3-risposta1
###################################################
enne <- 433
valoriDistintiX <- c(3.86,4.26,4.46,4.96,5.66)
FrequenzaCum <- c(0.263,0.478,0.751,0.891,1)
FrequenzaRel <- diff(c(0,FrequenzaCum))
FrequenzaAss <- round(enne*FrequenzaRel,0)
matrix(c(valoriDistintiX,FrequenzaRel),ncol=2,dimnames=list(character(5),c("Area fogliare","Freq")))


###################################################
### chunk number 8: 1-4-3-risposta2a
###################################################
valoriElementari <- rep(valoriDistintiX,FrequenzaAss)
cutset <- c(0,3.36,4.36,4.76,5.96,7.66,10.66)
cat("Frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/enne
cat("Densit di frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/(enne*diff(cutset))


###################################################
### chunk number 9: 1-4-3-risposta2b
###################################################
hist(valoriElementari,breaks=cutset,freq=F,right=TRUE,plot=T,main="Istogramma di Area fogliare",xlab="Area fogliare",ylab="Densit di frequenza relativa")


###################################################
### chunk number 10: 1-4-3-risposta3
###################################################
varpop <- varpopol(valoriElementari)
coefvar <- coefVariaz(valoriElementari)
differenzainterquartile <- as.numeric(diff(quantile(valoriElementari,probs =c(0.25,0.75) ,type=1)))
Ssm <- sum(abs(valoriElementari - mean(valoriElementari))/length(valoriElementari))
matrix(c(varpop,coefvar*100,differenzainterquartile,Ssm),nrow=4,dimnames=list(c("S2:","CV%:","Differenza interquartile:","Ssm:"),character(1)))


###################################################
### chunk number 11: 1-4-4-risposta1
###################################################
indicatore <- c(1,1,1,2,2,2)
valoriElementariX <- c(110,107,107,103,109,112);
Media <- mean(valoriElementariX)
Varpop <- varpopol(valoriElementariX)
matrix(c(Media,Varpop),nrow=2,dimnames=list(c("Media:","S2:"),c("Tea & Caffe")))


###################################################
### chunk number 12: 1-4-4-risposta2
###################################################
Media1 <- mean(valoriElementariX[indicatore=="1"])
Varpop1 <- varpopol(valoriElementariX[indicatore=="1"])
Media2 <- mean(valoriElementariX[indicatore=="2"])
Varpop2 <- varpopol(valoriElementariX[indicatore=="2"])
matrix(c(Media1,Varpop1,Media2,Varpop2),nrow=2,dimnames=list(c("Media:","S2:"),c("Tea","Caffe")))


###################################################
### chunk number 13: 1-4-5-risposta1
###################################################
enne <- 170
valoriDistintiX <- c("Nulla","Bassa","Media","Alta")
FrequenzaAss <- c(17,25,30,98)
matrix(c(4:1,FrequenzaAss),nrow=4,dimnames=list(c("Nulla:","Bassa:","Media:","Alta:"),c("Y","Freq")))


###################################################
### chunk number 14: 1-4-5-risposta2
###################################################
valoriElementari <- rep(valoriDistintiX,FrequenzaAss)
variabileY <- factor(valoriElementari)
levels(variabileY) <- c(4,3,2,1)
etichetta <- valoriDistintiX[FrequenzaAss==max(FrequenzaAss)]
#cat("Moda: ",etichetta,"\n")
mediana <- quantiB(as.numeric(variabileY))
cat("Mediana = Moda = ",mediana,"\n")


###################################################
### chunk number 15: 1-4-5-risposta3
###################################################
cat("Quantile 0.15: ",quantiB(as.numeric(variabileY),prob=0.15),"\n")
cat("Quantile 0.85: ",quantiB(as.numeric(variabileY),prob=0.85),"\n")


###################################################
### chunk number 16: 1-4-5-risposta4
###################################################
pie(FrequenzaAss, labels= valoriDistintiX)


###################################################
### chunk number 17: 1-4-6-risposta1
###################################################
enne <- 134
valoriDistintiX <- 100:109
FrequenzaAss <- c(2,7,6,11,25,19,31,17,12,4)
valoriElementari <- rep(valoriDistintiX,FrequenzaAss)
quantile(valoriElementari,prob=seq(0.1,0.9,0.1),type=1)


###################################################
### chunk number 18: 1-4-6-risposta2a
###################################################
cutset <- c(100,103,106,109)
cat("Frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/enne
cat("Densit di frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/(enne*diff(cutset))


###################################################
### chunk number 19: 1-4-6-risposta2b
###################################################
hist(valoriElementari,breaks=cutset,freq=F,right=TRUE,plot=T,main="Istogramma di Y",ylab="Densit di frequenza relativa",xlab="y",xlim=c(100,110),ylim=c(0,0.25))


###################################################
### chunk number 20: 1-4-6-risposta3
###################################################
raggrupClassi <- hist(valoriElementari, breaks=cutset,right=TRUE,plot=F)
frequenzeRelativeDiClasse <- raggrupClassi$counts/length(valoriElementari)
q1 <- 100 + 0.1*(103-100)/frequenzeRelativeDiClasse[1]
q2 <- 103 + (0.2-frequenzeRelativeDiClasse[1])*(106-103)/frequenzeRelativeDiClasse[2]
q3 <- 103 + (0.3-frequenzeRelativeDiClasse[1])*(106-103)/frequenzeRelativeDiClasse[2]
q4 <- 103 + (0.4-frequenzeRelativeDiClasse[1])*(106-103)/frequenzeRelativeDiClasse[2]
q5 <- 103 + (0.5-frequenzeRelativeDiClasse[1])*(106-103)/frequenzeRelativeDiClasse[2]
q6 <- 103 + (0.6-frequenzeRelativeDiClasse[1])*(106-103)/frequenzeRelativeDiClasse[2]
q7 <- 103 + (0.7-frequenzeRelativeDiClasse[1])*(106-103)/frequenzeRelativeDiClasse[2]
q8 <- 106 + (0.8-frequenzeRelativeDiClasse[1]-frequenzeRelativeDiClasse[2])*(109-106)/frequenzeRelativeDiClasse[3]
q9 <- 106 + (0.9-frequenzeRelativeDiClasse[1]-frequenzeRelativeDiClasse[2])*(109-106)/frequenzeRelativeDiClasse[3]
matrix(c(q1,q2,q3,q4,q5,q6,q7,q8,q9),ncol=9,dimnames=list(character(1),paste(seq(10,90,by=10),"%",sep="")))


###################################################
### chunk number 21: 1-4-7-risposta1
###################################################
valoriDistintiX <- c(17,19,25,26,32)
FrequenzaAss <- c(783,792,855,920,646)
enne <- sum(FrequenzaAss)
valoriElementari <- rep(valoriDistintiX,FrequenzaAss)
fiveNumbersSummary(valoriElementari)


###################################################
### chunk number 22: 1-4-7-risposta2a
###################################################
cutset <- c(0,18.1,26.7,33.5)
cat("Frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/enne
cat("Densit di frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/(enne*diff(cutset))


###################################################
### chunk number 23: 1-4-7-risposta2b
###################################################
raggrupClassi <- hist(valoriElementari,breaks=cutset,right=TRUE,plot=F)
hist(valoriElementari,breaks=cutset,freq=F,right=TRUE,plot=T,main="Istogramma di Y",xlab="Y",ylab="Densit di frequenza relativa",xlim=c(0,40),ylim=c(0,0.1))
box()


###################################################
### chunk number 24: 1-4-7-risposta3
###################################################
barplot(raggrupClassi$density,names.arg=raggrupClassi$mids,ylim=c(0,0.1),ylab="Densit di frequenza relativa",main="Diagramma di frequenze relative")
box()


###################################################
### chunk number 25: 1-4-8-risposta1
###################################################
brembana <- c(57,141,191)
seriana <- c(56,189,255)
torta <- c(81,222,308)
FrequenzeAssolute <- list()
FrequenzeAssolute[[1]] <- diff(c(0,brembana))
FrequenzeAssolute[[2]] <- diff(c(0,seriana))
FrequenzeAssolute[[3]] <- diff(c(0,torta))
frequenzeCongiunte <- matrix(c(
FrequenzeAssolute[[1]],
FrequenzeAssolute[[2]],
FrequenzeAssolute[[3]]) 
,3,3,byrow=T,
dimnames = list(c("X = 0","X = 1","X = 2"),c("Y = 1","Y = 2","Y = 3"))
)
frequenzeCongiunte 


###################################################
### chunk number 26: 1-4-8-risposta2
###################################################
enne <- sum(frequenzeCongiunte)
marginaleY <- apply(frequenzeCongiunte,2,sum)
matrix(c(1:3,marginaleY/enne),nrow=3,dimnames=list(character(3),c("Y","Freq")))


###################################################
### chunk number 27: 1-4-8-risposta3
###################################################
valoriElementari <- rep(c(1,2,3),marginaleY);
plot(ecdf(valoriElementari),main="Funzione di distribuzione empirica di Y",xlab="y",ylab="Fn(y)")


###################################################
### chunk number 28: 1-4-9-risposta1
###################################################
valoriElementari <- c(235.4,236,239.4,236,235,231.8,235,235,235.4,235,232,235.4,235,239.2,236,235.4,231.7)
svaloriElementari <- sort(valoriElementari)
matrix(c(unique(svaloriElementari),as.vector(table(svaloriElementari))),nrow=8,dimnames=list(character(8),c("X","Freq")))


###################################################
### chunk number 29: 1-4-9-risposta2
###################################################
cat("Quantile 0.705: ",quantiB(valoriElementari, 0.705),"\n")


###################################################
### chunk number 30: 1-4-9-risposta3
###################################################
boxPstd(valoriElementari)


###################################################
### chunk number 31: 
###################################################
data(esercizio.1.4.10)
DFlavoro <- esercizio.1.4.10


###################################################
### chunk number 32: 1-4-10-risposta1
###################################################
par(mfrow=c(2,1))
boxPstd(DFlavoro$Raccolto[DFlavoro$Varieta=="1"])
title(paste("Boxplot varieta\' ",1))
boxPstd(DFlavoro$Raccolto[DFlavoro$Varieta=="2"])
title(paste("Boxplot varieta\' ",2))


###################################################
### chunk number 33: 1-4-10-risposta2
###################################################
matrix(100*as.vector(tapply(DFlavoro$Commestibile,DFlavoro$Varieta,coefVariaz)),nrow=2,dimnames=list(c("v1:","v2:"),"CV%"))


###################################################
### chunk number 34: 1-4-10-risposta3
###################################################
dime <- nrow(DFlavoro)
varianza <- var(DFlavoro$Raccolto,DFlavoro$Commestibile)*(dime-1)/dime
correlazione <- cor(DFlavoro$Raccolto,DFlavoro$Commestibile)
cat("Covarianza: ",varianza,"\n")
cat("Indice r di correlazione lineare: ",correlazione,"\n")


###################################################
### chunk number 35: 1-4-10-risposta4
###################################################
cutset <- c(33,34,36,40,50)
table(cut(DFlavoro$Raccolto,breaks=cutset,include.lowest=T))


###################################################
### chunk number 36: 1-4-11-risposta1
###################################################
valoriElementari <- c(189,176,176,191,189,191,176,176,191,176) 
media <- mean(valoriElementari)
cat("Media (grammi): ",media,"\n")
cat("Media (Kg): ",media/1000,"\n")


###################################################
### chunk number 37: 1-4-11-risposta2
###################################################
diffsemplice <- difSempliceMed(valoriElementari)
cat("D1: ",diffsemplice,"\n")


###################################################
### chunk number 38: 1-4-11-risposta3
###################################################
Mediana <- quantile(valoriElementari,prob=0.5,type=1)
cat("Mediana: ",Mediana,"\n")


###################################################
### chunk number 39: 1-4-12-risposta1
###################################################
valoriDistinti <- c(9.9,10.0,10.1,10.2)
FrequenzeCum <- c(0.13,0.57,0.63,1.0)
enne <- 786
FrequenzeAss <- round(enne*diff(c(0,0.13,0.57,0.63,1.0)),0)
valoriElementari <- rep(valoriDistinti,FrequenzeAss)
cat("Moda: ",as.numeric(names(moda(valoriElementari))),"\n")


###################################################
### chunk number 40: 1-4-12-risposta2
###################################################
cat("Quantile 0.57: ",quantiB(valoriElementari,0.57),"\n")
cat("Quantile 0.25: ",quantiB(valoriElementari,0.25),"\n")
cat("Quantile 0.77: ",quantiB(valoriElementari,0.77),"\n")


###################################################
### chunk number 41: 1-4-13-risposta1
###################################################
valoriDistinti <- c(171,192,251,269,327)
FrequenzeAss <- c(513,524,552,560,524)
enne <- 2673
valoriElementari <- rep(valoriDistinti,FrequenzeAss)
cat("Differenza interquartile: ",diff(quantile(valoriElementari,prob=c(0.25,0.75),type=1)),"\n")
cat("Differenza interdecile: ",diff(quantile(valoriElementari,prob=c(0.1,0.9),type=1)),"\n")


###################################################
### chunk number 42: 1-4-13-risposta2a
###################################################
cutset <- c(0,193,271,350)
cat("Frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/enne


###################################################
### chunk number 43: 1-4-13-risposta2b
###################################################
cat("Densit di frequenza relativa per classe:\n")
table(cut(valoriElementari,cutset,include.lowest=T))/(enne*diff(cutset))


###################################################
### chunk number 44: 1-4-13-risposta2c
###################################################
hist(valoriElementari,breaks=cutset,prob=T,plot=T,main="Istogramma di Y",ylab="Densit di  frequenza relativa",xlab="y",ylim=c(0,0.01),xlim=c(0,400))


###################################################
### chunk number 45: 
###################################################
data(esercizio.1.4.14)
DFlavoro <- esercizio.1.4.14


###################################################
### chunk number 46: 1-4-14-risposta1
###################################################
ftable(DFlavoro,row.vars=c("Lunghezza","Diametro"),col.vars="Peso")
ftable(DFlavoro,row.vars=c("Peso","Lunghezza"),col.vars="Diametro")
ftable(DFlavoro,row.vars=c("Diametro","Lunghezza"),col.vars="Peso")


###################################################
### chunk number 47: 1-4-14-risposta2
###################################################
table(DFlavoro[,c("Diametro","Peso")])
enne <- 15
cat("chiquadro: ",summary(table(DFlavoro[,c("Diametro","Peso")]))$statistic/(enne*2),"\n")
cat("gradi di libert: ",(3-1)*(3-1),"\n")


###################################################
### chunk number 48: 1-4-14-risposta3
###################################################
table(DFlavoro[,c("Lunghezza","Peso")])
cat("Indice r di correlazione lineare: ",cor(DFlavoro[,"Lunghezza"],DFlavoro[,"Peso"]),"\n")


###################################################
### chunk number 49: 1-4-14-risposta4
###################################################
table(DFlavoro[,c("Diametro")])/15


###################################################
### chunk number 50: 1-4-14-risposta5
###################################################
table(DFlavoro[,c("Diametro","Peso")])/cbind(c(6,6,6),c(6,6,6),c(3,3,3))


###################################################
### chunk number 51: 1-4-14-risposta6
###################################################
stars(DFlavoro[1:4,])


###################################################
### chunk number 52: 1-4-15-risposta1
###################################################
valoriElementari <- c(76,87.4,48.5,52.9,25.9)
cat("D1: ",difSempliceMed(valoriElementari),"\n")


###################################################
### chunk number 53: 1-4-15-risposta2
###################################################
massimo <- max(valoriElementari)
campovariaz <- max(valoriElementari)-min(valoriElementari)
coefficientevariaz <- coefVariaz(valoriElementari)
matrix(c(massimo,campovariaz,coefficientevariaz*100),nrow=3,dimnames=list(c("Massimo:","Acv:","CV%:"),character(1)))


