###################################################
### chunk number 1: 
###################################################
library(ISA)


###################################################
### chunk number 2: 3-4-1-risposta1
###################################################
X <- list(val=1:3,prob=c(0.5,0.25,0.25))
cat("X: ",X$val,"\n")


###################################################
### chunk number 3: 3-4-1-risposta2
###################################################
matrix(c(X$val,X$prob),nrow=3,dimnames=list(character(3),c("X","P(X=x)")))


###################################################
### chunk number 4: 3-4-1-risposta3
###################################################
prob <- c(0.5,0.25,0.25)
distrdoppia <- outer(prob,prob,"*")
dimnames(distrdoppia) <- list(c("Y1=1","Y1=2","Y1=3"),c("Y2=1","Y2=2","Y2=3"))
distrdoppia


###################################################
### chunk number 5: 3-4-1-risposta4
###################################################
X <- list(val=2:6,prob=c(0.25,0.125+0.125,0.125+0.0625+0.125,0.0625+0.0625,0.0625))
matrix(c(X$val,X$prob),nrow=5,dimnames=list(character(5),c("X","P(X=x)")))


###################################################
### chunk number 6: 3-4-2-risposta1
###################################################
Y <- list(val=2*1:6,prob=c(0.5*0.5,0.5*0.5,0.5*0.5*0.5*0.5,3*0.5*0.5*0.5*0.5,3*0.5*0.5*0.5*0.5,0.5*0.5*0.5*0.5))
matrix(c(Y$val,Y$prob),nrow=6,dimnames=list(character(6),c("Y","P(Y=y)")))


###################################################
### chunk number 7: 3-4-2-risposta2
###################################################
Z <- list(val=2*1:2,prob=c(0.5*0.5+0.5*0.5*0.5*0.5,1-(0.5*0.5+0.5*0.5*0.5*0.5)))
matrix(c(Z$val,Z$prob),nrow=2,dimnames=list(character(2),c("Z","P(Z=z)")))


###################################################
### chunk number 8: 3-4-3-risposta1
###################################################
miamatrice <- as.matrix(cbind(expand.grid(X1=c(1,3),X2=c(1,3),X3=c(1,3)),rep(1,8)/8))
dimnames(miamatrice)<-list(character(8),c("X1","X2","X3","P(X1=x1,X2=x2,X3=x3)"))
miamatrice


###################################################
### chunk number 9: 3-4-3-risposta2
###################################################
Y <- list(val=c(3,5,7,9),prob=c(0.5*0.5*0.5,3*0.5*0.5*0.5,3*0.5*0.5*0.5,0.5*0.5*0.5))
matrix(c(Y$val,Y$prob),nrow=4,dimnames=list(character(4),c("Y","P(Y=y)")))


###################################################
### chunk number 10: 
###################################################
repliche <- 10000
enne <- 5
minimo <- 98
massimo <- 112
matrice <- matrix(data=runif(n=repliche*enne,min=minimo,max=massimo),nrow=repliche,ncol=enne)
res <- apply(matrice,MARGIN=1,FUN=IQR)


###################################################
### chunk number 11: 3-4-4-risposta1
###################################################
cat("matrice <- matrix(data=runif(n=10000*5,min=98,max=112),nrow=10000,ncol=5)\n")
cat("matrice\n")


###################################################
### chunk number 12: 3-4-4-risposta2a
###################################################
cat("res <- apply(matrice,MARGIN=1,FUN=IQR)\n")
cat("fiveNumbersSummary(res)\n")


###################################################
### chunk number 13: 3-4-4-risposta2b
###################################################
hist(res,prob=T,main="Istogramma distribuzione campionaria IQR",ylab="frequenza relativa",xlab="IQR")


###################################################
### chunk number 14: 3-4-4-risposta3
###################################################
cat("Modello di popolazione: 1-punif(q=110,min=98,max=112)\n")
cat("Stima: sum(as.vector(matrice)>110)/(10000*5)\n")


###################################################
### chunk number 15: 3-4-5-risposta1
###################################################
alpha <- 0.1
enne <- 19
S2n <- 0.0031
l1 <- enne*S2n/qchisq(1-alpha/2,df=enne)
l2 <- enne*S2n/qchisq(alpha/2,df=enne)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 16: 3-4-5-risposta2
###################################################
cat("Incertezza: ",l2-l1,"\n")


###################################################
### chunk number 17: 3-4-6-risposta1
###################################################
n1 <- 31
n2 <- 48
media1 <- 37.57
media2 <- 37.71
var1 <- var2 <- 0.16
alpha <- 0.12
zcrit <- qnorm(1-alpha/2)
l1 <- media1-media2 - zcrit*sqrt(var1/n1+var2/n2)
l2 <- media1-media2 + zcrit*sqrt(var1/n1+var2/n2)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 18: 3-4-6-risposta2
###################################################
cat("Incertezza: ",l2-l1,"\n")


###################################################
### chunk number 19: 3-4-7-risposta1
###################################################
nsucc <- 71
enne <- 213
phat <- nsucc/enne
cat("phat: ",phat,"\n")


###################################################
### chunk number 20: 3-4-7-risposta2
###################################################
alpha <- 0.01
zcrit <- qnorm(1-alpha/2)
l1 <- phat-zcrit*sqrt(phat*(1-phat)/enne)
l2 <- phat+zcrit*sqrt(phat*(1-phat)/enne)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 21: 3-4-8-risposta1
###################################################
enne <- 28
noncommestibili <- enne-11
phat <- noncommestibili/enne
cat("phat: ",phat,"\n")


###################################################
### chunk number 22: 3-4-8-risposta2
###################################################
alpha <- 0.05
zcrit <- qnorm(1-alpha/2)
l1 <- phat-zcrit*sqrt(phat*(1-phat)/enne)
l2 <- phat+zcrit*sqrt(phat*(1-phat)/enne)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 23: 3-4-9-risposta1
###################################################
data(esercizio.1.4.10)
Raccolto <- esercizio.1.4.10[,"Raccolto"]
Varieta <- esercizio.1.4.10[,"Varieta"]
meanONLYv2 <- mean(Raccolto[Varieta=="2"])
cat("Media: ",meanONLYv2,"\n")
varONLYv2 <- var(Raccolto[Varieta=="2"])
cat("Varianza: ",varONLYv2,"\n")


###################################################
### chunk number 24: 3-4-9-risposta2
###################################################
sigma2 <- 3.5**2
incertezza <- 1
alpha <- 0.07 
zcrit <- qnorm(1-alpha/2)
enne <- ceiling(sigma2*(2*zcrit/incertezza)**2)
cat("n: ",enne,"\n")


###################################################
### chunk number 25: 3-4-10-risposta1
###################################################
capacita <- 0.75
enne <- 111
nonAdatteVendita <- 37
phat <- nonAdatteVendita/enne
cat("phat: ",phat,"\n")


###################################################
### chunk number 26: 3-4-10-risposta2
###################################################
alpha <- 0.02
zcrit <- qnorm(1-alpha/2)
l1 <- phat-zcrit*sqrt(phat*(1-phat)/enne)
l2 <- phat+zcrit*sqrt(phat*(1-phat)/enne)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 27: 3-4-11-risposta1
###################################################
enne <- 129
distribuzione <- matrix(c(8,5,38,26,31,21),ncol=2,nrow=3,byrow=T)
X <- list(val=0:1,freq=c(8+38+31,5+26+21))
matrix(c(X$val,X$freq),nrow=2,dimnames=list(character(2),c("X","Freq")))
Y <- list(val=0:2,freq=c(8+5,38+26,31+21))
matrix(c(Y$val,Y$freq),nrow=3,dimnames=list(character(3),c("Y","Freq")))


###################################################
### chunk number 28: 3-4-11-risposta2
###################################################
abeteOfaggio <- sum(distribuzione[2:3,])
phat <- abeteOfaggio/enne
alpha <- 0.05
zcrit <- qnorm(1-alpha/2)
l1 <- phat-zcrit*sqrt(phat*(1-phat)/enne)
l2 <- phat+zcrit*sqrt(phat*(1-phat)/enne)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 29: 3-4-12-risposta2
###################################################
varianza <- 25
enne <- 5
media <- 2000
alpha <- 0.08
zcrit <- qnorm(1-alpha/2)
l1 <- media-zcrit*sqrt(varianza/enne)
l2 <- media+zcrit*sqrt(varianza/enne)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 30: 3-4-13-risposta1
###################################################
enne <- 25
difettate <- 6
livello <- 0.87
phat <- difettate/enne
alpha <- 1-livello
zcrit <- qnorm(1-alpha/2)
l1 <- phat-zcrit*sqrt(phat*(1-phat)/enne)
l2 <- phat+zcrit*sqrt(phat*(1-phat)/enne)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 31: 3-4-14-risposta1
###################################################
enne <- 25
sommaY <- 2205
S2n <- 14.7
mediaY <- sommaY/enne
stimavar <- S2n*(enne)/(enne-1)
cat("varianza: ",stimavar,"\n")


###################################################
### chunk number 32: 3-4-14-risposta2
###################################################
alpha <- 0.05
l1 <- (enne-1)*stimavar/qchisq(1-alpha/2,df=enne-1)
l2 <- (enne-1)*stimavar/qchisq(alpha/2,df=enne-1)
cat("Intervallo di confidenza: (",l1,",",l2,")\n")


###################################################
### chunk number 33: 3-4-14-risposta3
###################################################
prob <- 1-pnorm(90,mean=mediaY,sd=sqrt(stimavar))
cat("probabilit: ",prob,"\n")


###################################################
### chunk number 34: 3-4-15-risposta1
###################################################
cat("matrice<-matrix(data=rnorm(n=10000*5,mean=105,sd=6),nrow=10000,ncol=5)\n")
cat("matrice\n")


###################################################
### chunk number 35: 3-4-15-risposta2
###################################################
cat("resS1 <- apply(matrice,MARGIN=1,FUN=min)")
cat("resS2 <- apply(matrice,MARGIN=1,FUN=mean)")
cat("mean(resS1)")
cat("var(resS1)")
cat("mean(resS2)")
cat("var(resS1)")


